/*
 * This file was generated by the CommonAPI Generators.
 * Used org.genivi.commonapi.someip 3.2.0.v202012010944.
 * Used org.franca.core 0.13.1.201807231814.
 *
 * This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
 * If a copy of the MPL was not distributed with this file, You can obtain one at
 * http://mozilla.org/MPL/2.0/.
 */
#ifndef V2_TEST_AUDIO_CONTROLLER_SOMEIP_PROXY_HPP_
#define V2_TEST_AUDIO_CONTROLLER_SOMEIP_PROXY_HPP_

#include <v2/Test/Audio/ControllerProxyBase.hpp>
#include <v2/Test/Audio/ControllerSomeIPDeployment.hpp>

#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#define HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE
#endif

#include <CommonAPI/SomeIP/Factory.hpp>
#include <CommonAPI/SomeIP/Proxy.hpp>
#include <CommonAPI/SomeIP/Types.hpp>
#include <CommonAPI/SomeIP/Attribute.hpp>
#include <CommonAPI/SomeIP/Event.hpp>

#if defined (HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE)
#undef COMMONAPI_INTERNAL_COMPILATION
#undef HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE
#endif

#include <string>

# if defined(_MSC_VER)
#  if _MSC_VER >= 1300
/*
 * Diamond inheritance is used for the CommonAPI::Proxy base class.
 * The Microsoft compiler put warning (C4250) using a desired c++ feature: "Delegating to a sister class"
 * A powerful technique that arises from using virtual inheritance is to delegate a method from a class in another class
 * by using a common abstract base class. This is also called cross delegation.
 */
#    pragma warning( disable : 4250 )
#  endif
# endif

namespace v2 {
namespace Test {
namespace Audio {

class ControllerSomeIPProxy
    : virtual public ControllerProxyBase,
      virtual public CommonAPI::SomeIP::Proxy {
public:
    ControllerSomeIPProxy(
        const CommonAPI::SomeIP::Address &_address,
        const std::shared_ptr<CommonAPI::SomeIP::ProxyConnection> &_connection);

    virtual ~ControllerSomeIPProxy();

    virtual IVIDeviceInfoAttribute& getIVIDeviceInfoAttribute();

    virtual AudioSourceTypesAttribute& getAudioSourceTypesAttribute();

    virtual VolumeInfoAttribute& getVolumeInfoAttribute();

    virtual KeyValueByteBufferMapAttribute& getKeyValueByteBufferMapAttribute();

    virtual DeviceStateMapAttribute& getDeviceStateMapAttribute();

    virtual StringToShortMapAttribute& getStringToShortMapAttribute();

    virtual FocusStatusChangedEvent& getFocusStatusChangedEvent();

    /*
     * description: 
     * The ccRC system requests to obtain audio focus.
     */
    virtual void ObtainFocus(std::string _audioSourceType, Controller::AudioDeviceType _device, CommonAPI::CallStatus &_internalCallStatus, Controller::FocusControlError &_error, Controller::AudioFocusResultType &_res, const CommonAPI::CallInfo *_info);

    virtual std::future<CommonAPI::CallStatus> ObtainFocusAsync(const std::string &_audioSourceType, const Controller::AudioDeviceType &_device, ObtainFocusAsyncCallback _callback, const CommonAPI::CallInfo *_info);

    /*
     * description: 
     * The ccRC system requests to release audio focus.  Requests that cannot be released return errors.
     */
    virtual void ReleaseFocus(std::string _audioSourceType, Controller::AudioDeviceType _device, CommonAPI::CallStatus &_internalCallStatus, Controller::FocusControlError &_error, const CommonAPI::CallInfo *_info);

    virtual std::future<CommonAPI::CallStatus> ReleaseFocusAsync(const std::string &_audioSourceType, const Controller::AudioDeviceType &_device, ReleaseFocusAsyncCallback _callback, const CommonAPI::CallInfo *_info);

    /*
     * description: 
     * Set the volume for outside the system.
     */
    virtual void SetVolume(uint8_t _volume, CommonAPI::CallStatus &_internalCallStatus, Controller::VolumeControlError &_error, const CommonAPI::CallInfo *_info);

    virtual std::future<CommonAPI::CallStatus> SetVolumeAsync(const uint8_t &_volume, SetVolumeAsyncCallback _callback, const CommonAPI::CallInfo *_info);

    /*
     * description: 
     * request to set source volume.
     * There are two member field in the Input parameter.
     * - AudioSourceType: please see "AudioSourceTypes []" for finding detail description
     * - volume : it holds volume level and its level is depending on platform's audio  spec. (varies based on platform, model, misc.)
     * : when this method is invoked, audio manager need to update VolumeInfo.LastVolume
     * 
     * - maxVolume : it defines volume limitation which is described from the requirement
     * - VolumeControlError : please see "setVolume" for more detail explanation
     */
    virtual void SetSourceVolume(std::string _audioSourceType, uint16_t _volume, uint32_t _maxVolume, CommonAPI::CallStatus &_internalCallStatus, Controller::VolumeControlError &_error, const CommonAPI::CallInfo *_info);

    virtual std::future<CommonAPI::CallStatus> SetSourceVolumeAsync(const std::string &_audioSourceType, const uint16_t &_volume, const uint32_t &_maxVolume, SetSourceVolumeAsyncCallback _callback, const CommonAPI::CallInfo *_info);

    /*
     * description: 
     * Get FocusStatus and VolumeInfo for audio source type
     */
    virtual void GetAudioSourceStatus(std::string _audioSourceType, CommonAPI::CallStatus &_internalCallStatus, Controller::ErrorType &_error, Controller::AudioSourceStatusInfo &_audioSourceStatusInfo, const CommonAPI::CallInfo *_info);

    virtual std::future<CommonAPI::CallStatus> GetAudioSourceStatusAsync(const std::string &_audioSourceType, GetAudioSourceStatusAsyncCallback _callback, const CommonAPI::CallInfo *_info);

    virtual void getOwnVersion(uint16_t &_major, uint16_t &_minor) const;

    virtual std::future<void> getCompletionFuture();

private:
    CommonAPI::SomeIP::ObservableAttribute<CommonAPI::SomeIP::Attribute<IVIDeviceInfoAttribute, ::v2::Test::Audio::Controller_::KeyValueStringDeployment_t>> iVIDeviceInfo_;
    CommonAPI::SomeIP::ObservableAttribute<CommonAPI::SomeIP::ReadonlyAttribute<AudioSourceTypesAttribute, CommonAPI::SomeIP::ArrayDeployment< CommonAPI::SomeIP::StringDeployment >>> audioSourceTypes_;
    CommonAPI::SomeIP::ObservableAttribute<CommonAPI::SomeIP::ReadonlyAttribute<VolumeInfoAttribute, ::v2::Test::Audio::Controller_::VolumeInfoDeployment_t>> volumeInfo_;
    CommonAPI::SomeIP::ObservableAttribute<CommonAPI::SomeIP::ReadonlyAttribute<KeyValueByteBufferMapAttribute, ::v2::Test::Audio::Controller_::KeyValueByteBufferDeployment_t>> keyValueByteBufferMap_;
    CommonAPI::SomeIP::ObservableAttribute<CommonAPI::SomeIP::ReadonlyAttribute<DeviceStateMapAttribute, ::v2::Test::Audio::Controller_::DeviceStateMapDeployment_t>> deviceStateMap_;
    CommonAPI::SomeIP::ObservableAttribute<CommonAPI::SomeIP::ReadonlyAttribute<StringToShortMapAttribute, ::v2::Test::Audio::Controller_::StringToShortMapDeployment_t>> stringToShortMap_;
    CommonAPI::SomeIP::Event<FocusStatusChangedEvent, CommonAPI::Deployable< std::vector< ::v2::Test::Audio::Controller::FocusStatus >, CommonAPI::SomeIP::ArrayDeployment< ::v2::Test::Audio::Controller_::FocusStatusDeployment_t > >> focusStatusChanged_;

    std::promise<void> completed_;
};

} // namespace Audio
} // namespace Test
} // namespace v2

#endif // V2_TEST_AUDIO_Controller_SOMEIP_PROXY_HPP_
